Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/486.html

486. Predict the Winner (Medium)

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Example 1:

Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2. 
If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2).
So, final score of player 1 is 1 + 2 = 3, and player 2 is 5.
Hence, player 1 will never be the winner and you need to return False.

Example 2:

Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

Companies:
Google, Works Applications

Related Topics:
Dynamic Programming, Minimax

Solution 1. DP

Let dp[len][i] be the winning score gap of subarray starting from nums[i] with length len.

dp[len][i] = max{
                nums[i] - dp[len - 1][i],
                nums[i + len - 1] - dp[len - 1][i]
            }

Where 2 <= len <= N and 0 <= i <= N - len.

For len = 1, dp[1][i] = nums[i].

// OJ: https://leetcode.com/problems/predict-the-winner/
// Time: O(N^2)
// Space: O(N^2)
class Solution {
public:
    bool PredictTheWinner(vector<int>& nums) {
        int N = nums.size();
        unordered_map<int, unordered_map<int, int>> dp;
        for (int i = 0; i < N; ++i) dp[i][1] = nums[i];
        for (int len = 2; len <= N; ++len) {
            for (int i = 0; i <= N - len; ++i) {
                dp[i][len] = max(nums[i] - dp[i + 1][len - 1], nums[i + len - 1] - dp[i][len - 1]);
            }
        }
        return dp[0][N] >= 0;
    }
};

Solution 2. Optimized DP

Since dp[len][i] is only dependent on dp[len - 1][i] and dp[len - 1][i], we can reduce the space from O(N^2) to O(N).

// OJ: https://leetcode.com/problems/predict-the-winner/
// Time: O(N^2)
// Space: O(N)
class Solution {
public:
    bool PredictTheWinner(vector<int>& nums) {
        int N = nums.size();
        vector<int> dp(N);
        for (int i = 0; i < N; ++i) dp[i] = nums[i];
        for (int len = 2; len <= N; ++len)
            for (int i = 0; i <= N - len; ++i)
                dp[i] = max(nums[i] - dp[i + 1], nums[i + len - 1] - dp[i]);
        return dp[0] >= 0;
    }
};

Java

  • public class Solution {
        public boolean PredictTheWinner(int[] nums) {
            if (nums == null || nums.length == 0)
                return false;
            int length = nums.length;
            int[][] dp = new int[length][length];
            for (int i = 0; i < length; i++)
                dp[i][i] = nums[i];
            for (int i = length - 2; i >= 0; i--) {
                for (int j = i + 1; j < length; j++)
                    dp[i][j] = Math.max(nums[i] - dp[i + 1][j], nums[j] - dp[i][j - 1]);
            }
            return dp[0][length - 1] >= 0;
        }
    }
    
  • // OJ: https://leetcode.com/problems/predict-the-winner/
    // Time: O(N^2)
    // Space: O(N^2)
    class Solution {
    public:
        bool PredictTheWinner(vector<int>& nums) {
            int N = nums.size();
            unordered_map<int, unordered_map<int, int>> dp;
            for (int i = 0; i < N; ++i) dp[i][1] = nums[i];
            for (int len = 2; len <= N; ++len) {
                for (int i = 0; i <= N - len; ++i) {
                    dp[i][len] = max(nums[i] - dp[i + 1][len - 1], nums[i + len - 1] - dp[i][len - 1]);
                }
            }
            return dp[0][N] >= 0;
        }
    };
    
  • class Solution:
        def PredictTheWinner(self, nums: List[int]) -> bool:
            @cache
            def dfs(i, j):
                if i > j:
                    return 0
                a = min(dfs(i + 1, j), dfs(i, j - 1))
                return s[j + 1] - s[i] - a
    
            s = list(accumulate(nums, initial=0))
            return dfs(0, len(nums) - 1) * 2 >= s[-1]
    
    ############
    
    class Solution(object):
      def PredictTheWinner(self, nums):
        """
        :type nums: List[int]
        :rtype: bool
        """
    
        def canWin(nums, start, end, visited, partSum, maxSum, order):
          # print "canWin order=", order
          if (start, end, partSum, order) in visited:
            return visited[start, end, partSum, order]
          if start > end:
            # print "order=", order, partSum, maxSum
            if order == 0:
              if partSum >= maxSum - partSum:
                return False
              return True
            else:
              if partSum >= maxSum - partSum:
                return True
              return False
    
          visited[start, end, partSum, order] = False
          if not canWin(nums, start + 1, end, visited, partSum - order * nums[start], maxSum, ~order):
            visited[start, end, partSum, order] = True
            # print "order=", order, "return True"
            return True
          if not canWin(nums, start, end - 1, visited, partSum - order * nums[end], maxSum, ~order):
            visited[start, end, partSum, order] = True
            # print "order=", order, "return True"
            return True
          return visited[start, end, partSum, order]
    
        return canWin(nums, 0, len(nums) - 1, {}, 0, sum(nums), -1)
    
    

All Problems

All Solutions